-- stack module
function NewStack()
    return { top = 0 }
end

-- stack ũ push, pop ΰ Լ 
function PushStack(stack, value)
	local newTop = stack.top + 1
	stack[newTop] = value
	stack.top = newTop
end

function PopStack(stack)
	if stack.top == 0 then
    	return nil
	end

	local oldTop = stack.top
	local retValue = stack[oldTop]
	stack.top = oldTop - 1
	stack[oldTop] = nil
	return retValue
end

function PeekStack(stack, index)
    if stack.top + index > 0 then
        return string.lower(stack[stack.top + index])
    else
        return nil
    end
end


-- Download RSS XML file
local socket = require("socket.http")
local content, retCode = socket.request("http://lua-users.org/wiki/.rss")


-- Check Downlaod XML file exactly
if retCode == 200 then
	targetString = content
else
	print("Cannot download XML file from web-site")
	return
end

--Start parsing
local i = 0
local currentElement = ""
local textPT = 0;

local stack = NewStack()

while true do
	i, j, slash, element, attribute = string.find(targetString, "<(%/?)(%w+)(.-)(%/?)>", i + 1)     	
  	
    if i == nil then break end
    currentElement = string.lower(element)
   
    if string.len(slash) == 0 then
        PushStack(stack, currentElement)
        if PeekStack(stack, 0) == "item" then
            print("===================================================================")       
        end
        textPT = j + 1;
    else   
        if PeekStack(stack, -1) == "item" then
            print(PeekStack(stack, 0), string.sub(targetString, textPT, i - 1))
        elseif PeekStack(stack, 0) == "item" then
            print("===================================================================")       
        end
       
        PopStack(stack)
    end  
end