﻿-- ChannelFilter v1.0
-- by Dsp

local Org_MsgEventHandler = ChatFrame_MessageEventHandler;
local prev_msg = nil;

local function Print(msg) 
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function CFilter_OnEvent(event)
	if event == "VARIABLES_LOADED" then
		if ( not gCFilter ) then
			gCFilter = {};
			gCFilter.bFiltering = false;
			gCFilter.tFilters = {};
			gCFilter.party_channel = 0;
		end

		Print("|c0000ff00Channel Filter|r v1.0 Loaded");

		-- 채널 번호 표시
		Print("채널 설정 : |c0000ff00"..gCFilter.party_channel);
		-- 필터 활성화 유무 표시
		if gCFilter.bFiltering then
			Print("필터 상태 :|c0000ff00 ON");
		else
			Print("필터 상태 :|cffffff00 OFF");
		end
		-- 등록된 필터들 표시
		local text="";
		for key, value in pairs(gCFilter.tFilters) do
			text = text.."[|c0000ff00"..value.."|r],";
		end
		if table.getn(gCFilter.tFilters)>0 then
			Print("추가된 필터들 : "..text);
		end
			
	end
end

function ChatFrame_MessageEventHandler(event)
	if (event=="CHAT_MSG_CHANNEL") then
		local text = arg1;
		local channel = arg8;
		local channel_name = arg4;
		local author = arg2;
		
		-- filtering이 시작되지 않았으면 아무 동작 안함.
		if not gCFilter.bFiltering then
			Org_MsgEventHandler(event);
			return;
		end
		
		local info = ChatTypeInfo["CHANNEL"];
		local bShow = false;
		
		if ( channel == gCFilter.party_channel ) then
		  if ( prev_msg ~= text ) then
		  	-- filter list의 단어가 포함되면 표시.
		  	-- 아니면 무시.
		  	for key, value in pairs(gCFilter.tFilters) do
		  		text, nMatch = gsub(text, value, "|c0000ff00"..value.."|r");
		  		if ( nMatch>0 ) then
		  			bShow = true;
		  		end
		  	end
				if bShow and prev_msg ~= text then
					prev_msg = text;
					text = "["..channel_name.."] ["..author.."] : "..text;
					DEFAULT_CHAT_FRAME:AddMessage(text, info.r, info.g, info.b, info.id);
				end
			end
		else
			Org_MsgEventHandler(event);
		end
	else
		Org_MsgEventHandler(event);
	end
end

function CFilter_OnLoad()
	SlashCmdList["CFILTER"] = CFilter_Exec;
	SLASH_CFILTER1 = "/필터";
	SLASH_CFILTER2 = "/cfilter";
	this:RegisterEvent("VARIABLES_LOADED");
end

function CFilter_Exec(msg)
	local cmd, argument;

	msg = strtrim(msg);
	cmd = gsub(msg, "^(.-)%s+(.*)", "%1");
	argument = gsub(msg, "^(.-)%s+(.*)", "%2");

	if (cmd=="시작" or string.upper(cmd)=="ON") then
		gCFilter.bFiltering = true;
		Print("채널 필터 기능을 시작합니다.");
	elseif (cmd=="중지" or string.upper(cmd)=="OFF") then
		gCFilter.bFiltering = false;
		Print("채널 필터 기능을 중지합니다.");
	elseif (cmd == "추가" or string.upper(cmd)=="ADD") then
		if ( argument ) then
			tinsert(gCFilter.tFilters, argument);
			Print("[|c0000ff00"..argument.."|r] 필터를 추가합니다.");
		else
			Print("/필터 추가 \"표시할 필터\"");
			Print("ex. /필터 추가 카라잔");
		end
	elseif (cmd == "삭제" or string.upper(cmd)=="DELETE") then
		if ( argument ) then
			for key, value in pairs(gCFilter.tFilters) do
				if value==argument then
					tremove(gCFilter.tFilters, key);
					Print("[|c0000ff00"..argument.."|r] 필터를 삭제합니다.");
				end
			end
		else
			Print("/필터 삭제 \"표시할 필터\"");
			Print("ex. /필터 삭제 카라잔");
		end
	elseif (cmd == "모두삭제" or string.upper(cmd)=="RESET") then
		gCFilter.tFilters = {};
		Print("모든 필터들을 삭제합니다.");
	elseif (cmd == "채널" or string.upper(cmd)=="CHANNEL") then
		if ( argument and tonumber(argument)~=nil ) then
			gCFilter.party_channel = tonumber(argument);
			Print("채널 설정 : |c0000ff00"..argument);
		else
			Print("/필터 채널 \"필터를 적용할 채널 번호\"");
			Print("ex. /필터 채널 6");		
		end
	else
		local stat;
		local text = "";
		Print("/필터 시작 | 중지 | 추가 | 삭제 | 채널 | 모두삭제");
		Print("/cfilter on | off | add | delete | channel | reset");
		for key, value in pairs(gCFilter.tFilters) do
			text = text.."[|c0000ff00"..value.."|r],";
		end
		if gCFilter.bFiltering then
			Print("상태 :|c0000ff00 ON");
		else
			Print("상태 :|cffffff00 OFF");
		end
		
		Print("채널 설정 : |cffffff00"..gCFilter.party_channel);
		
		if table.getn(gCFilter.tFilters)>0 then
			Print("추가된 필터들 : "..text);
		end
	end
end
