﻿-- Author      : Dsp
-- Create Date : 5/16/2008 9:26:03 PM

local Org_MsgEventHandler = ChatFrame_MessageEventHandler;
local prev_msg = nil;
local Filters = nil;

local function Print(msg) 
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function ChatFrame_MessageEventHandler(event)
	if ( event=="CHAT_MSG_CHANNEL") then
		local text = arg1;
		local channel = arg8;
		local channel_name = arg4;
		local author = arg2;
		
		-- filtering이 시작되지 않았으면 아무 동작 안함.
		if not gCFilter.bFiltering then
			Org_MsgEventHandler(event);
			return;
		end
		
		local info = ChatTypeInfo["CHANNEL"];
		local bShow = false;
		
		if ( channel == gCFilter.party_channel ) then
		  if ( prev_msg ~= text ) then
		  	-- filter list의 단어가 포함되면 표시.
		  	-- 아니면 무시.
		  	for key, value in pairs(gCFilter.tFilters) do
		  		text, nMatch = gsub(text, value, "|c0000ff00"..value.."|r");
		  		if ( nMatch>0 ) then
		  			bShow = true;
		  		end
		  	end
				if bShow and prev_msg ~= text then
					prev_msg = text;
					text = "["..channel_name.."] ["..author.."] : "..text;
					DEFAULT_CHAT_FRAME:AddMessage(text, info.r, info.g, info.b, info.id);
				end
			end
		else
			Org_MsgEventHandler(event);
		end
	else
		Org_MsgEventHandler(event);
	end
end

function Start_OnClick()
	Filters = strFilters:GetText();
	FilterList = { strsplit(",", Filters) };
	
	gCFilter.tFilters = {};
	for key,filter in pairs(FilterList) do
		tinsert( gCFilter.tFilters, strtrim(filter) );
	end
	
	ShowFilters();
	gCFilter.bFiltering = true;
	Print("채널 필터 기능을 시작합니다.");	
end

function Stop_OnClick()
	gCFilter.bFiltering = false;
	Print("채널 필터 기능을 중지합니다.");
end

function strFilters_OnTextChanged()
	Filters = strFilters:GetText();
	Print( "Filter : "..Filters );
end

function ChannelNumber_OnTextChanged()
	gCFilter.party_channel = ChannelNumber:GetNumber();
	if ( gCFilter.party_channel > 0 ) then
		Print("채널 설정 : |c0000ff00"..gCFilter.party_channel );
	end
end

function Close_OnClick()
	Frame1:Hide();
	Print("설정창을 다시 띄우려면 '/필터'나 '/cfilter' 명령을 치세요.");
end

function Frame1_OnLoad()
	SlashCmdList["CFILTER"] = CFilter_Exec;
	SLASH_CFILTER1 = "/필터";
	SLASH_CFILTER2 = "/cfilter";
	Frame1:RegisterEvent("VARIABLES_LOADED");
end

function CFilter_Exec()
	Frame1:Show();
end

function Frame1_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		if ( not gCFilter ) then
			gCFilter = {};
			gCFilter.bFiltering = false;
			gCFilter.tFilters = {};
			gCFilter.party_channel = 0;
		end

		Print("|c0000ff00Channel Filter|r v1.0 Loaded");

		-- 채널 번호 표시
		Print("채널 설정 : |c0000ff00"..gCFilter.party_channel);
		-- 필터 활성화 유무 표시
		if gCFilter.bFiltering then
			Print("필터 상태 :|c0000ff00 ON");
		else
			Print("필터 상태 :|cffffff00 OFF");
		end
		
		ChannelNumber:SetText( tostring(gCFilter.party_channel) );
		local text="";
		for key,value in pairs(gCFilter.tFilters) do
			if key==1 then
				text = value;
			else
				text = text..","..value;
			end
		end
		strFilters:SetText( text );
		
		ShowFilters();
	end
end

function ShowFilters()
	-- 등록된 필터들 표시
	local text="";
	for key, value in pairs(gCFilter.tFilters) do
		text = text.."[|c0000ff00"..value.."|r],";
	end
	if table.getn(gCFilter.tFilters)>0 then
		Print("추가된 필터들 : "..text);
	end
end