﻿-- Author      : dsp
-- Create Date : 5/18/2008 12:00:00 PM


FunctionMap = {
	format=testFormat,
	gsub=testGsub,
	strbyte=testStrbyte,
	strchar=testStrchar,
	strfind=testStrfind,
	strjoin=testStrjoin,
	strlen=testStrlen,
	strlower=testStrlower,
	strmatch=testStrmatch,
	strrep=testStrrep,
	strsub=testStrsub,
	strsplit=testStrsplit,
	strupper=testStrupper,
	strtrim=testStrtrim
};

function testFormat()
	hello = "Hello";
	a = 108;
	
	result = format( "%s\n", hello );
	result = result .. format( "%q\n", hello );
	result = result .. format( "%e, %E\n", math.pi, math.pi );
	result = result .. format( "%d, %f\n", math.pi, math.pi );
	result = result .. format( "%o, %x, %X", a, a, a );
	
	return result;
end

function testGsub()
	hello = "Hello, world\n";
	result = gsub( hello, "l", "L" );
	result = result .. gsub( hello, "l", "L", 2 );
	
	result = result .. gsub( hello, "(ll)", "%1oooo");
	result = result .. gsub( hello, "(l)(o)", "%2%1" );
	
	result = result .. gsub( hello, "l", strupper );

	return result;
end

function testStrbyte()
	hello = "Hello";
	result = strbyte( hello );
	result = result.."\n".. strbyte( hello, 1 );
	result = result.."\n".. strbyte( hello, 2 );
	result = result.."\n".. strbyte( hello, 4 );
	result = result.."\n".. strbyte( hello, 5 );
	return result;
end

function testStrchar()
	return strchar( 72, 101, 108, 108, 111 );
end

function testStrfind()
	hello = "Hello, world\n";
	result = strfind( hello, "l" );
	result = result.."\n"..strfind( hello, "l", 1 );
	result = result.."\n"..strfind( hello, "l", 5 );
	result = result.."\n"..strfind( hello, "l", -5 );
	return result;
end

function testStrjoin()
	return strjoin( "\n", "Hello,", "World" );
end

function testStrlen()
	result = strlen( "" );
	result = result.."\n"..strlen( "Hello" );
	return result;
end

function testStrlower()
	return strlower( "Hello, World!" );
end

function testStrmatch()
	hello = "Hello, world\n";
	result = strmatch( hello, "l" );
	result = result.."\n"..strmatch( hello, "%w+" );
	result = result.."\n"..strmatch( hello, "w%w+" );
	return result;
end

function testStrrep()
	result = strrep( "hi,", 0 );
	result = result .."\n".. strrep( "hi,", 3 );
	return result;
end

function testStrsub()
	hello = "Hello, world.";
	result = strsub( hello, 8 );
	result = result .. "\n"..strsub( hello, 8, -1 );
	result = result .. "\n"..strsub( hello, -6, -2 );
	return result;
end

function testStrsplit()
	result = "";
	s = "hi,guyz, this is, kinda test";
	splitedStrings = { strsplit( ",", s ) };
	for k,v in pairs(splitedStrings) do
		result = result..v.."\n";
	end
	return result;
end

function testStrtrim()
	result = "";
	s = "hi,guyz, this is, kinda test";
	splitedStrings = { strsplit( ",", s ) };
	for k,v in pairs(splitedStrings) do
		result = result..strtrim(v).."\n";
	end
	return result;
end

function testStrupper()
	return strupper( "hello, world!" );
end

function FuncName_OnTextChanged()
	func = FuncName:GetText();
	
	if ( FunctionMap[ func ] ) then
		ResultText = FunctionMap[ func ]();
	else
		ResultText="Invalid Function Name !";
	end
	
	Result:SetText( ResultText );
end
