﻿-- Author      : dsp
-- Create Date : 5/18/2008 12:00:00 PM


FunctionMap = {
	AbandonQuest=testAbandonQuest,
	AcceptQuest=testAcceptQuest,
	CompleteQuest=testCompleteQuest,
	testFriend=testFrien,
	testInspect=testInspect,
	testChannel1=testChannel1,
	testChannel2=testChannel2,
	BagName=testBagName,
	GetMaxSlots=testGetContainerNumSlots,
	GetContainerItemInfo=testGetContainerItemInfo,
	PickupContainerItem=testPickupContainerItem,
	ChangeActionBarPage=testChangeActionBarPage,
	GetInboxNumItems=testGetInboxNumItems,
	GetInboxHeaderInfo=testGetInboxHeaderInfo,
	testHookfunc=testHookfunc
}

function testHookfunc()
	--게임에서 유저가 로그 아웃 할때, 발생하는 Logout 이 불릴경우,
	--원하는 작별인사말을 원하는 창에 올립니다.		
	hooksecurefunc('Logout', function()
		SendChatMessage("ByeBye");		
	end);	

	result = "hooking function이 등록되었습니다.";
	return result;
end

function testGetInboxHeaderInfo()
	CheckInbox();
	_, _, sender, subject, money, CODamount, daysLeft = GetInboxHeaderInfo(1);
	result = sender.."로 부터 온 "..subject.." 우편입니다.\n";
	result = result..format("반송 까지 앞으로 %d일 남았습니다.\n", daysLeft);
	result = result.."본문 내용:\n"..GetInboxText(1);
	return result;
end


function testGetInboxNumItems()
	CheckInbox();
	result = "현재 우편함에 "..GetInboxNumItems().."개의 우편물이 있습니다."; 
	return result;
end

function testChangeActionBarPage()	
	ChangeActionBarPage(3);
	result = "Change ActionBar 3";
	return result;
end

function testPickupContainerItem()
	 if CursorHasItem() then
	 	result = "Move Item";
	 	PickupContainerItem(2, 1);	 
	 else
	 	result = "Pick up Item";
	 	PickupContainerItem(2, 1);	 
	 end
	 return result;
end

function testGetContainerItemInfo()
	--가방속의 아이템 중에서 epic quality 아이템의 위치만 표시합니다.
	result = "Poor quality item's index = \n";
  	for bagIndex = 0,4 do
    	for slot = 1,GetContainerNumSlots(bagIndex) do
      		local texture, itemCount, locked, quality, readable = GetContainerItemInfo(bagIndex, slot);
      		if quality == 4 then
      			result = result.."( "..bagIndex..", "..slot.." )\n";
      		end
    	end
	end
	return result;
end


function testGetContainerNumSlots()
	-- 가방 slot에 가방이 있으면, 가방의 크기를 출력합니다.
	result = "";
	for i = 0, 4 do
		if GetContainerNumSlots(i) > 0 then
			result = result.."Bag["..i.."]'s Size = "..GetContainerNumSlots(i).."\n";
		end		
	end			
	return result;
end

function testBagName()
	-- 가방 slot에 가방이 있으면, 가방의 이름을 출력합니다.
	result = "";
	for i = 0, 4 do
		if GetBagName(i) ~= nil then
			result = result.."Bag["..i.."] = "..GetBagName(i).."\n";
		end		
	end			
	return result;
end

function testBagName()
	-- 가방 slot에 가방이 있으면, 가방의 이름을 출력합니다.
	result = "";
	for i = 0, 4 do
		if GetBagName(i) ~= nil then
			result = result.."Bag["..i.."] = "..GetBagName(i).."\n";
		end		
	end			
	return result;
end

function testChannel1()
	--AURA 라는 채널을 생성	
	JoinChannelByName("AURA", nil, DEFAULT_CHAT_FRAME:GetID());	
	ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, "AURA");
	result = "AURA channel 생성\n";
	return result
end

function testChannel2()
	local channelID = GetChannelName("AURA");	
	result = "AURA의 채널ID = "..channelID.."\n";
	--생성한 채널에 메세지를 전송합니다.
	SendChatMessage("내가 만든 채널에 메세지를 보낸다.", "CHANNEL", nil, channelID);
	result = result.."메세지 전송 완료\n";
	LeaveChannelByName("AURA");
	result = result.."AURA channel에서 나감\n";
	return result;
end

function testInspect()
	--살펴볼 수 있는 거리 안에 있고, 다른 유저의 케릭이면 살펴보기 수행
	if CheckInteractDistance("target", 1) then
		if UnitPlayerControlled("target") then 
			if not UnitIsUnit("player", "target") then
  				InspectUnit("target");
  				result = UnitName("target").."를 살펴봅니다.";	
  				return result
  			end
  		end
  	end
end

function testFriend()
	local firstFriend;
	result = "current friends :";
	for i = 1, GetNumFriends() do
		local name, level, class, loc, connected, status = GetFriendInfo(i);
		firstFriend = name;
		result = result ..name.."\n";
	end
	AddFriend("네오꾼");
	result = result .."네오꾼 친구 추가\n";
	
	RemoveFriend(firstFriend)
	result = result .. format("%s 친구 삭제\n", firstFriend);
	return result
end


function testCompleteQuest()
	CompleteQuest();
	result = "Called CompleteQuest()";
	return result
end


function testAcceptQuest()
	AcceptQuest();
	result = "Called AcceptQuest()";
	return result
end

function testAbandonQuest()
	SetAbandonQuest();
	AbandonQuest();
	result = "Called SetAbandonQuest() and AbandonQuest()";
	return result;
end


function FuncName_OnTextChanged()
	func = FuncName:GetText();
	
	if ( FunctionMap[ func ] ) then
		ResultText = FunctionMap[ func ]();
	else
		ResultText="Invalid Function Name !";
	end
	
	Result:SetText( ResultText );
end
